#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>
#include <string>
#include <string.h>

#include "TTree.h"
#include "TFile.h"
#include "TString.h"

#include "TSystem.h"
#include "THaEvent.h"
#include "THaRun.h"
#include "TH1.h"
#include "TH2.h"
#include "TCanvas.h"
#include "TStyle.h"

#include "def.h"

using namespace std;

void do_calculation(char *filename, int nev)
{
  double Ebeam = 1.195; //[GeV]
  
  Double_t DL_t7[100];
  Double_t DL_t6[100];
  Double_t DL_evtypebits;
  Double_t L_tr_n;
  Double_t BB_tr_n;
  Double_t BB_tr_p[100];
  Double_t L_tr_p[100];

  Double_t L_tr_px[100];
  Double_t L_tr_py[100];
  Double_t L_tr_pz[100];

  Double_t BB_tr_px[100];
  Double_t BB_tr_py[100];
  Double_t BB_tr_pz[100];

  Double_t BB_tr_x[100];
  Double_t BB_tr_y[100];
  Double_t BB_tr_ph[100];
  Double_t BB_tr_th[100];
  

  Double_t missmass;


  
  cout << "Reading file " << endl;
  TFile *f1 = new TFile(filename, "UPDATE");
  TTree *t1 = (TTree*) f1->Get("T");
  assert(t1);
  
  int num =  t1->GetEntries();
  cout<<"Number of entries: "<<num<<endl;

  if (nev<num && nev>0) num = nev;
   
  
  t1->SetBranchAddress( "DL.t7", &DL_t7);
  t1->SetBranchAddress( "DL.t6", &DL_t6);
  t1->SetBranchAddress( "DL.evtypebits", &DL_evtypebits);
  t1->SetBranchAddress( "L.tr.n", &L_tr_n);
  t1->SetBranchAddress( "BB.tr.n", &BB_tr_n);
  t1->SetBranchAddress( "L.tr.p", &L_tr_p);
  t1->SetBranchAddress( "BB.tr.p", &BB_tr_p);
 

  t1->SetBranchAddress( "L.tr.px", &L_tr_px);
  t1->SetBranchAddress( "L.tr.py", &L_tr_py);
  t1->SetBranchAddress( "L.tr.pz", &L_tr_pz);

  t1->SetBranchAddress( "BB.tr.px", &BB_tr_px);
  t1->SetBranchAddress( "BB.tr.py", &BB_tr_py);
  t1->SetBranchAddress( "BB.tr.pz", &BB_tr_pz);

  t1->SetBranchAddress( "BB.tr.x", &BB_tr_x);
  t1->SetBranchAddress( "BB.tr.y", &BB_tr_y);
  t1->SetBranchAddress( "BB.tr.th", &BB_tr_th);
  t1->SetBranchAddress( "BB.tr.ph", &BB_tr_ph);
  
  

//________________ Histograms without cut____________________________
  TH1F *HCTime7 = new TH1F("CTime7","Coinc Time7", 100, -5.0, 80.0);
  TH1F *HCTime7bg = new TH1F("CTime7bg","Coinc Time7 backgorund", 100, -5.0, 80.0);
  TH1F *HCTime7noCut = new TH1F("CTime7noCut","Coinc Time7 without cut", 100, -5.0, 80.0);
  TH1F *HCTime6 = new TH1F("CTime6","Coinc Time6", 100, -100.0, 100.0);
  TH1F *hLmomentum = new TH1F("Lmomentum","Left arm momentum", 200, 0.0, 2.0);
  TH1F *hLenergy = new TH1F("Lenergy","Left arm energy", 200, 0.9, 1.1);
  TH1F *hBBmomentum = new TH1F("Bmomentum","BB momentum", 200, 0.0, 0.9);
  TH1F *hBBenergy = new TH1F("BBenergy","BB energy", 200, 0.9, 1.2);
  TH1F *hMissingEnergy = new TH1F("MissingEnergy","Missing Energy", 200, -0.1, 0.3);
  TH1F *hMissingMomentum = new TH1F("MissingMomentum","Missing Momentum", 200, -0.05, 0.4);

  TH1F *hMissingMass = new TH1F("MissingMass","Missing Mass", 200, -0.05, 0.25);
  TH1F *hMissingMassBg = new TH1F("MissingMassBg","Missing Mass Background", 200, -0.05, 0.25);
  TH1F *hMissingMassFinal = new TH1F("MissingMassFinal","Missing Mass Final", 200, -0.05, 0.25);


  TH1F *hMissingMassSq = new TH1F("MissingMassSq","Missing Mass Sq", 200, -0.1, 0.1);
  TH1F *hMissingMassSqBg = new TH1F("MissingMassSqBg","Missing Mass Sq backgorund", 200, -0.1, 0.1);
  TH1F *hMissingMassSqFinal = new TH1F("hMissingMassSqFinal","Missing Mass Square Final.",200, -0.1, 0.1);

  TH1F *hW = new TH1F("W","Invariant mass", 200, 1.02, 1.14);
  TH1F *hThetapq = new TH1F("Thetapq","Theta_pq ", 200, 0.0, 90.0);

  TH1F *hpx = new TH1F("hpx","BB momentum px", 200, -0.6, 0.0);
  TH1F *hpy = new TH1F("hpy","BB momentum py", 200, -0.2, 0.3);
  TH1F *hpz = new TH1F("hpz","BB momentum pz", 200, 0.1, 0.6);

  TH1F *hqx = new TH1F("hqx","qx", 200, -0.4, -0.1);
  TH1F *hqy = new TH1F("hqy","qy", 200, -0.2, 0.2);
  TH1F *hqz = new TH1F("hqz","qz", 200, 0.15, 0.35);
  TH1F *hq = new TH1F("hq","q", 200, 0.25, 0.5);

  TH1F *hpqx = new TH1F("hpqx","px-qx", 200, -0.4, 0.4);
  TH1F *hpqy = new TH1F("hpqy","py-qy", 200, -0.4, 0.4);
  TH1F *hpqz = new TH1F("hpqz","pz-qz", 200, -0.4, 0.4);
  TH1F *hpq = new TH1F("hpq","|p|-|q|", 200, -0.4, 0.8);



  TH1F *hx = new TH1F("hx","BB x", 200, -2.0, -2.0);
  TH1F *hy = new TH1F("hy","BB y", 200, -0.5, 0.5);
  TH1F *hth = new TH1F("hth","BB th", 200, -0.5, 0.8);
  TH1F *hph = new TH1F("hph","BB ph", 200, -0.5, 0.5);

  TH2F *hMMSQvsCoincTime7 = new TH2F("hMMSQvsCoincTime","Coinc. time7 vs. Missing mass sq.",100, 20.0, 45.0,  100, -0.2, 0.1 );
	
  TH2F *hxy = new TH2F("hxy","X vs. y",100, -2.0, 2.0,  100, -0.5, 0.5);
  TH2F *hthph = new TH2F("hthph","th vs. ph",100, -0.5, 0.8,  100, -0.5, 0.5);

  TH2F *hxth = new TH2F("hxth","X vs. Th",100, -2.0, 2.0,  100, -0.5, 0.8);
  TH2F *hyph = new TH2F("hyph","Y vs. Ph",100, -0.5, 0.5,  100, -0.5, 0.5);

  for(int f = 0; f<=num; f++)
  {
	t1->GetEntry(f);
	if (f%1000==0 && f>0) cout<<f<<endl;
	//cout<<"************ Entry: "<<f<<" **********"<<endl;

	double BBx = BB_tr_x[0];
	double BBy = BB_tr_y[0];
	double BBth = BB_tr_th[0];
	double BBph = BB_tr_ph[0];

	
	//if ((((int)DL_evtypebits& 1<<5) ==1<<5) && ((int)L_tr_n==1) && ((int)BB_tr_n==1) && (BBx>-0.4 && BBx<0.4) && (BBy>-0.15 && BBy<0.15) && (BBth>-0.2 && BBth<0.2) && (BBph>-0.05 && BBph<0.05) )
	//if ((((int)DL_evtypebits& 1<<5) ==1<<5) && ((int)L_tr_n==1) && ((int)BB_tr_n==1) && ((BBx>0.1 && BBx<0.4) && (BBy>-0.05 && BBy<0.05) && (BBth>0.15 && BBth<0.3) && (BBph>-0.02 && BBph<0.04)))

	//  && (0.23/2.0*(BBx + 1.0)<BBth) && (BBth < 0.23/2.0*(BBx + 1.5))

	if ((((int)DL_evtypebits& 1<<5) ==1<<5) && ((int)L_tr_n==1) && ((int)BB_tr_n==1) && ((0.42*(BBy+0.5)-0.23 < BBph) && (BBph < 0.42*(BBy+0.5)-0.17) && (-0.5+0.775/2.0*(BBx + 1.0)<BBth) && (BBth < 0.775/2.0*(BBx + 1.5) - 0.5 ) ))
	{
	   double coinctime7 = 0.5*(DL_t7[0]-770); 
	   double coinctime6 = 0.5*(DL_t6[0]-770); 

	   double L_momentum = L_tr_p[0];
	   hLmomentum->Fill(L_momentum);	   
	   double L_energy = sqrt(L_momentum*L_momentum);
	   hLenergy ->Fill(L_energy);

	   double Lpx = L_tr_px[0];
	   double Lpy = L_tr_py[0];
	   double Lpz = L_tr_pz[0];

 	   double BB_momentum = BB_tr_p[0]; //!!!!!!! 
	   double BB_energy = sqrt(BB_momentum*BB_momentum + 0.938*0.938);		

 	   double BBpx = BB_tr_px[0]; //!!!!!!! 
	   double BBpy = BB_tr_py[0];
	   double BBpz = BB_tr_pz[0]; //!!!!!!! 

	   double omega = Ebeam - L_energy;

	   double qx = -Lpx; 
	   double qy = -Lpy;
	   double qz = sqrt(Ebeam*Ebeam) - Lpz;

	   double qsq = qx*qx + qy*qy + qz*qz;

	   double W = sqrt(omega*omega - qsq + 2.0*0.938*omega + 0.938*0.938); 

	   double missing_energy = Ebeam + 0.938 - BB_energy - L_energy;

	   double missing_momentum = sqrt((qx-BBpx)*(qx-BBpx) + (qy-BBpy)*(qy-BBpy) + (qz-BBpz)*(qz-BBpz));		
		
	   double missing_mass_sq = missing_energy*missing_energy - missing_momentum*missing_momentum;

	   double missing_mass = -123456.0;
	   if (missing_mass_sq>=0.0) missing_mass = sqrt(missing_mass_sq);


	   double arg = (qsq + BB_momentum*BB_momentum - missing_momentum*missing_momentum)/(2.0*sqrt(qsq)*BB_momentum);
	   double thetaqp = -123456.0;
	   if  (fabs(arg)<1.0) thetaqp = 180.0/3.141592*acos(arg);
	
	   
		
	   //______________ Histograms without cuts______________
	
	   HCTime7noCut->Fill(coinctime7);


	   // Cut on coinc time;
	   if (coinctime7>25.0 && coinctime7<40.0)
	   //if(BB_momentum>0.6)
           {
	     HCTime7->Fill(coinctime7);
	     HCTime6->Fill(coinctime6);
	     hBBmomentum->Fill(BB_momentum);
	     hBBenergy->Fill(BB_energy);

	     hMissingEnergy->Fill(missing_energy);
	     hMissingMomentum->Fill(missing_momentum);
	     hMissingMassSq->Fill(missing_mass_sq);
	     hMissingMass->Fill(missing_mass);

	     hpx->Fill(BBpx);
	     hpy->Fill(BBpy);
	     hpz->Fill(BBpz);

	     hqx->Fill(qx);
	     hqy->Fill(qy);
	     hqz->Fill(qz);
	     hq->Fill(sqrt(qsq));

	     hpqx->Fill(BBpx-qx);
	     hpqy->Fill(BBpy-qy);
	     hpqz->Fill(BBpz-qz);
	     hpq->Fill(BB_momentum-sqrt(qsq));


	     hx->Fill(BBx);
	     hy->Fill(BBy);
	     hth->Fill(BBth);
	     hph->Fill(BBph);

	     hxy->Fill(BBx,BBy);
	     hthph->Fill(BBth,BBph);

	     hxth->Fill(BBx,BBth);
	     hyph->Fill(BBy,BBph);

	     hW->Fill(W);
	     hThetapq->Fill(thetaqp);
		
	     hMMSQvsCoincTime7->Fill(coinctime7,missing_mass_sq);	
	   }

	   if (coinctime7>5.0 && coinctime7<20.0)
	   {
	     HCTime7bg->Fill(coinctime7);
	     hMissingMassSqBg->Fill(missing_mass_sq);
	     hMissingMassBg->Fill(missing_mass);
	   }

	}

  }

  hMissingMassSqFinal->Add(hMissingMassSq,hMissingMassSqBg,1,-1);
  hMissingMassFinal->Add(hMissingMass,hMissingMassBg,1,-1);

  t1->Delete();
  f1->Write();




  delete HCTime7;
  delete HCTime7bg;
  delete HCTime7noCut;
  delete HCTime6;
  delete hLmomentum;
  delete hLenergy;
  delete hBBmomentum;
  delete hBBenergy;
  delete hMissingEnergy;
  delete hMissingMomentum;
  delete hMissingMass;
  delete hMissingMassBg;
  delete hMissingMassFinal;
  delete hMissingMassSq;
  delete hMissingMassSqBg;
  delete hMissingMassSqFinal;
  delete hW;
  delete hThetapq;

  delete hpx;
  delete hpy;
  delete hpz;

  delete hqx;
  delete hqy;
  delete hqz;
  delete hq;

  delete hpqx;
  delete hpqy;
  delete hpqz;
  delete hpq;


  delete hx;
  delete hy;
  delete hth;
  delete hph;

  delete hMMSQvsCoincTime7;
	
  delete hxy;
  delete hthph;

  delete hxth;
  delete hyph;

  delete f1;
  
  
  
}



void physics3(Int_t runnumber=0, Int_t all=0 )
{
  int DefReplayNum = 20000;

  int nrun, nev;
  int found = 0;
  const char** path = 0;
  char filename[300], buf[300];;  
  FILE *fd;
  const char* paths[] = {  
    STD_REPLAY_OUTPUT_DIR,
    ".",
    0
  };
  nrun = runnumber;
  while( found==0 ) {

    if (nrun<=0 ){
      	cout << "Run number?\n";
      	cin >> nrun;
      	if( nrun<=0 ) break;
    }
  
    path=paths;  
    while ( path && *path ) {
      // sprintf(filename,"%s/e04007_phys_%d.root",*path,nrun);
      sprintf(filename,Phys_Replay.OutFileFormat,*path,nrun);
      fd = fopen(filename,"r");
      if (fd != NULL) {
	found = 1;
	cout << "Will analyze file "<<filename<<endl;
	break;
      }
      path++;
    }
    if ( (!path || !*path) && !found ) {
      cout << "File not found.  Try again, or -1 to quit.\n";
      nrun = 0;
      continue;
    }
  }
  if(nrun<0) return;
 
  // Lets pick the number of events

    if (all==0)
    {
        cout << "\nreplay: Number of Events to analyze "
            <<" (default=";
        if (DefReplayNum>0)
            cout<<DefReplayNum<<"):";
        else 
            cout<<"replay all):";


        //trick to support blank inputs
        fgets(buf,300,stdin);
        if (sscanf(buf,"%d\n",&nev)<1)
            nev=DefReplayNum;
    }
    else 
        nev=all;
   cout << "Opening file "<<filename<<endl;

   do_calculation(filename, nev);
}
